zoukankan      html  css  js  c++  java
  • CF Gym 100685A Ariel

    传送门

    A. Ariel
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    King Triton really likes watching sport competitions on TV. But much more Triton likes watching live competitions. So Triton decides to set up a swimming competition in the kingdom Merfolk. Thousands of creatures come to take part in competition, that's why it is too difficult to take the first place.

    For the King's beloved daughter Ariel this competition is the first in her life. Ariel is very kind, so she wants to give a lot of gold medals. Ariel says, that it is unfair to make a single ranking list for creatures that are so different. It is really a good result to be the fastest small fish without tail in Merfolk!

    Ariel chooses k important traits (such as size, tailness, rapacity and so on). A creature can either possess a trait or not (there are no intermediate options).

    A score is given for each creature (it doesn't matter how it was calculated) and the list of possessed traits f1, ..., fy is also given.

    Ariel wants to know the place occupied by creature a in a competition among creatures, who have the same traits h1, ..., ht. So if creature a doesn't have a trait hi, then all creatures in the competition are without this trait. If creature a has a trait hi, then all creatures in the competition have this trait. Other traits doesn't matter. The winner of the competition is a creature with the maximum score.

    Input

    The first line contains n (1 ≤ n ≤ 104) and k (1 ≤ k ≤ 10). The next n lines contain information about creatures: score (1 ≤ score ≤ 109), y (0 ≤ y ≤ k) — the number of possessed traits, and y numbers fi (1 ≤ fi ≤ k) — ids of possessed traits. All fi in one line are different.

    The next line contains m (1 ≤ m ≤ 105) — the number of queries from Ariel. The next m lines describe queries: a (1 ≤ a ≤ n) — the id of a creature, then t — the number of traits, then t numbers hi. All hi in one line are different.

    Output

    For each query output the place of a creature a in ranking list amount the corresponded creatures. If several creatures have the same score all of them take the same place.

    Examples
    Input
    3 2
    100 1 1
    50 1 2
    30 2 1 2
    12
    1 2 1 2
    1 1 1
    1 1 2
    1 0
    2 0
    2 1 1
    2 1 2
    2 2 2 1
    3 0
    3 2 1 2
    3 1 2
    3 1 1
    Output
    1
    1
    1
    1
    2
    1
    1
    1
    3
    1
    2
    2
    Input
    3 2
    100 0
    10 0
    100 0
    3
    1 0
    2 0
    3 0
    Output
    1
    3
    1

    Solution:
    (1)(看起来)比较暴力的做法:

    预处理:将属性相同的选手的score放在一个vector里,排序.这样共得到$2^{k}$个vector.

    查询:在每个合法属性对应的vector里二分查找比该score大的score的数目.

    Implememtation:

     1 #include <bits/stdc++.h>
     2 using namespace std;
     3 
     4 const int N=1<<10, M=1e4+5;
     5 
     6 vector<int> a[N];
     7 int s[M], st[M];
     8 
     9 int main(){
    10     int n, k, m;
    11     cin>>n>>k;
    12     for(int i=1, c; i<=n; i++){
    13         cin>>s[i]>>c;
    14         for(int t; c--; cin>>t, st[i]|=1<<t-1);
    15         a[st[i]].push_back(s[i]);
    16     }
    17     for(int i=0; i<1<<k; i++)
    18         sort(a[i].begin(), a[i].end());
    19     cin>>m; 
    20     for(int id, c, t, mask; m--; ){
    21         cin>>id>>c;
    22         mask=0;
    23         for(int i=0, x; i<c; i++)
    24             cin>>x, mask|=1<<x-1;
    25         int ans=0;
    26         for(int i=0; i<1<<k; i++)
    27             if((st[id]&mask)==(i&mask))
    28                 ans+=a[i].end()-upper_bound(a[i].begin(), a[i].end(), s[id]);
    29         cout<<ans+1<<endl;
    30     }
    31     return 0;
    32 }

    事实证明,这个做法真的没那么暴力.

    (2)将所有可能的查询的结果算出来(打表),这样查询的复杂度是$O(1)$的.

    把查询查询中要求和id相同的那些属性压缩到一个$k$位整数$s$中(将$s$的对应位置1),存在$res[id][s]$中.

    用$st[i]$表示第i个选手的属性,不难看出$res[id][s]$对应的比赛的选手集合为:

    [C_{id, s} ={i: st[i] & s = st[id]& s}]

    由此,我们将$C_{id, s}$,写成$C_{st[id]&s}$

    考虑在s固定的情况下,如何计算res[1..n][s].

    我们用(id, score)表示一个选手, 先将各选手按score从大到小排序。然后逐个放到$C_{st[id]&s}$中,其实这样是将选手照其$st[id]&s$分成了若干等价类.这样便可在某个等价类内O(1)地计算res[i][s]。总复杂度是$O(Nlog(N)+2^{k}N)$。

    Implementation:

    #include <bits/stdc++.h>
    using namespace std;
    
    
    const int N(1<<10), M(1e4+5);
    vector<pair<int,int>> a, b[N];
    int res[M][N], st[M];
    
    int main(){
        int n, k;
        cin>>n>>k;
        for(int i=1, c, t, sc; i<=n; i++){
            cin>>sc>>c;
            for(; c--; cin>>t, st[i]|=1<<t-1);  //error-prone
            a.push_back({sc, i});
        }
    
        sort(a.begin(), a.end(), greater<pair<int,int>>());
    
        for(int i=0; i<1<<k; i++){
            for(int i=0; i<1<<k; i++)
                b[i].clear();
            for(auto x: a)
                b[st[x.second]&i].push_back(x);
            for(int j=0; j<1<<k; j++)
                for(int k=1; k<b[j].size(); k++)
                    if(b[j][k].first==b[j][k-1].first)
                        res[b[j][k].second][i]=res[b[j][k-1].second][i];
                    else 
                        res[b[j][k].second][i]=k;
        }
        int m;
        cin>>m;
        for(; m--; ){
            int mask=0, c, id, t;
            cin>>id>>c;
            for(; c--; cin>>t, mask|=1<<t-1);
            cout<<res[id][mask]+1<<endl;
        }
        return 0;
    }
  • 相关阅读:
    jchdl
    jchdl
    UVa 11134 (区间上的贪心) Fabled Rooks
    UVa (二分) 11627 Slalom
    POJ 1037 (计数 + DP) 一个美妙的栅栏
    HDU 3448 Bag Problem
    HDu 3449 (有依赖的01背包) Consumer
    POJ 1456 (贪心+并查集) Supermarket
    POJ 2236 (简单并查集) Wireless Network
    POJ 1703 Find them, Catch them
  • 原文地址:https://www.cnblogs.com/Patt/p/5565551.html
Copyright © 2011-2022 走看看